KDE 4.7 PyKDE API Reference

- KDE's Python API

# SlaveBase Class Reference

`from PyKDE4.kio import *`

Namespace: KIO

## Detailed Description

There are two classes that specifies the protocol between application (job) and kioslave. SlaveInterface is the class to use on the application end, SlaveBase is the one to use on the slave end.

Slave implementations should simply inherit SlaveBase

A call to foo() results in a call to slotFoo() on the other end.

## Enumerations
MessageBoxType | { QuestionYesNo, WarningYesNo, WarningContinueCancel, WarningYesNoCancel, Information, SSLMessageBox }
VirtualFunctionId | { AppConnectionMade }
## Methods
| __init__ (self, QByteArray protocol, QByteArray pool_socket, QByteArray app_socket)
| __init__ (self, KIO.SlaveBase other)
KIO.MetaData | allMetaData (self)
bool | cacheAuthentication (self, KIO.AuthInfo info)
bool | canResume (self, long offset)
| canResume (self)
bool | checkCachedAuthentication (self, KIO.AuthInfo info)
| chmod (self, KUrl url, int permissions)
| chown (self, KUrl url, QString owner, QString group)
| close (self)
| closeConnection (self)
KConfigGroup | config (self)
| connectSlave (self, QString path)
int | connectTimeout (self)
| connected (self)
| copy (self, KUrl src, KUrl dest, int permissions, KIO.JobFlags flags)
| data (self, QByteArray data)
| dataReq (self)
| del_ (self, KUrl url, bool isfile)
| disconnectSlave (self)
| dispatch (self, int command, QByteArray data)
| dispatchLoop (self)
| dispatchOpenCommand (self, int command, QByteArray data)
| dropNetwork (self, QString host=QString())
| error (self, int _errid, QString _text)
| errorPage (self)
| exit (self)
| finished (self)
| get (self, KUrl url)
bool | hasMetaData (self, QString key)
| infoMessage (self, QString msg)
| listDir (self, KUrl url)
| listEntries (self, [KIO.UDSEntry] _entry)
| listEntry (self, KIO.UDSEntry _entry, bool ready)
| lookupHost (self, QString host)
int | messageBox (self, KIO.SlaveBase.MessageBoxType type, QString text, QString caption=QString(), QString buttonYes=i18n("&Yes"), QString buttonNo=i18n("&No"))
int | messageBox (self, QString text, KIO.SlaveBase.MessageBoxType type, QString caption=QString(), QString buttonYes=i18n("&Yes"), QString buttonNo=i18n("&No"), QString dontAskAgainName=QString())
QString | metaData (self, QString key)
| mimeType (self, QString _type)
| mimetype (self, KUrl url)
| mkdir (self, KUrl url, int permissions)
| multiGet (self, QByteArray data)
| needSubUrlData (self)
| open (self, KUrl url, QIODevice::OpenMode mode)
| openConnection (self)
bool | openPasswordDialog (self, KIO.AuthInfo info, QString errorMsg=QString())
| opened (self)
| position (self, long _pos)
| processedPercent (self, float percent)
| processedSize (self, long _bytes)
int | proxyConnectTimeout (self)
| put (self, KUrl url, int permissions, KIO.JobFlags flags)
| read (self, long size)
int | readData (self, QByteArray buffer)
int | readTimeout (self)
| redirection (self, KUrl _url)
KRemoteEncoding | remoteEncoding (self)
| rename (self, KUrl src, KUrl dest, KIO.JobFlags flags)
| reparseConfiguration (self)
bool | requestNetwork (self, QString host=QString())
int | responseTimeout (self)
| seek (self, long offset)
| sendAndKeepMetaData (self)
| sendMetaData (self)
| setHost (self, QString host, int port, QString user, QString pass)
| setKillFlag (self)
| setLinkDest (self, KUrl url, QString target)
| setMetaData (self, QString key, QString value)
| setModificationTime (self, KUrl url, QDateTime mtime)
| setSubUrl (self, KUrl url)
| setTimeoutSpecialCommand (self, int timeout, QByteArray data=QByteArray())
| slaveStatus (self, QString host, bool connected)
| slave_status (self)
| special (self, QByteArray data)
| speed (self, long _bytes_per_second)
| stat (self, KUrl url)
| statEntry (self, KIO.UDSEntry _entry)
| symlink (self, QString target, KUrl dest, KIO.JobFlags flags)
| totalSize (self, long _bytes)
int, int pCmd | waitForAnswer (self, int expected1, int expected2, QByteArray data)
int | waitForHostInfo (self, QHostInfo info)
| warning (self, QString msg)
bool | wasKilled (self)
| write (self, QByteArray data)
| written (self, long _bytes)

## Method Documentation

__init__ | ( | self, |
|  | QByteArray | protocol,
|  | QByteArray | pool_socket,
|  | QByteArray | app_socket
| ) |  |  |

__init__ | ( | self, |
|  | KIO.SlaveBase | other
| ) |  |  |

KIO.MetaData allMetaData | ( |  | self ) |

Internal:
  for ForwardingSlaveBase Contains all metadata (but no config) sent by the application to the slave.

bool cacheAuthentication | ( | self, |
|  | KIO.AuthInfo | info
| ) |  |  |

Caches info in a persistent storage like KWallet.

Starting with KDE 4.7, calling openPasswordDialog will no longer store passwords automatically for you. This was done to avoid accidental storage of incorrect or invalid password information.

Here is a simple example of how to use cacheAuthentication:

     AuthInfo info;
     info.url = KUrl("http://www.foobar.org/foo/bar");
     info.username = "somename";
     info.verifyPath = true;
     if ( !checkCachedAuthentication( info ) ) {
        if ( openPasswordDialog(info) ) {
            if (info.keepPassword)  {  // user asked password be save/remembered
                 cacheAuthentication(info);
            }
        }
     }

Parameters:

  | info | See AuthInfo.

Returns:
  true if info was successfully cached.

bool canResume | ( | self, |
|  | long | offset
| ) |  |  |

Call this at the beginning of get(), if the "resume" metadata was set and resuming is implemented by this protocol.

canResume | ( |  | self ) |

Call this at the beginning of get(), if the "resume" metadata was set and resuming is implemented by this protocol.

bool checkCachedAuthentication | ( | self, |
|  | KIO.AuthInfo | info
| ) |  |  |

Checks for cached authentication based on parameters given by info.

Use this function to check if any cached password exists for the URL given by info. If AuthInfo.realmValue and/or AuthInfo.verifyPath flag is specified, then they will also be factored in determining the presence of a cached password. Note that Auth.url is a required parameter when attempting to check for cached authorization info. Here is a simple example:

     AuthInfo info;
     info.url = KUrl("http://www.foobar.org/foo/bar");
     info.username = "somename";
     info.verifyPath = true;
     if ( !checkCachedAuthentication( info ) )
     {
        if ( !openPasswordDialog(info) )
         ....
     }

Parameters:

  |  | info See AuthInfo.

Returns:
  true if cached Authorization is found, false otherwise.

chmod | ( | self, |
|  | KUrl | url,
|  | int | permissions
| ) |  |  |

Change permissions on url The slave emits ERR_DOES_NOT_EXIST or ERR_CANNOT_CHMOD

chown | ( | self, |
|  | KUrl | url,
|  | QString | owner,
|  | QString | group
| ) |  |  |

Change ownership of url The slave emits ERR_DOES_NOT_EXIST or ERR_CANNOT_CHOWN

close | ( |  | self ) |

closeConnection | ( |  | self ) |

Closes the connection (forced) Called when the application disconnects the slave to close any open network connections.

When the slave was operating in connection-oriented mode, it should reset itself to connectionless (default) mode.

KConfigGroup config | ( |  | self ) |

Returns a configuration object to query config/meta-data information from.

The application provides the slave with all configuration information relevant for the current protocol and host.

connectSlave | ( | self, |
|  | QString | path
| ) |  |  |

internal function to connect a slave to/ disconnect from either the slave pool or the application

int connectTimeout | ( |  | self ) |

Returns:
  timeout value for connecting to remote host.

connected | ( |  | self ) |

Call in openConnection, if you reimplement it, when you're done.

copy | ( | self, |
|  | KUrl | src,
|  | KUrl | dest,
|  | int | permissions,
|  | KIO.JobFlags | flags
| ) |  |  |

Copy src into dest.

By default, copy() is only called when copying a file from yourproto://host/path to yourproto://host/otherpath.

If you set copyFromFile=true then copy() will also be called when moving a file from file:path to yourproto://host/otherpath. Otherwise such a copy would have to be done the slow way (get+put). See also KProtocolManager.canCopyFromFile().

If you set copyToFile=true then copy() will also be called when moving a file from yourproto: to file:. See also KProtocolManager.canCopyToFile().

If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for get + put instead.

Parameters:

  | src | where to copy the file from (decoded)
  | dest | where to copy the file to (decoded)
  | permissions | may be -1. In this case no special permission mode is set.
  | flags: | We support Overwrite here

Don't forget to set the modification time of dest to be the modification time of src.

data | ( | self, |
|  | QByteArray | data
| ) |  |  |

Sends data in the slave to the job (i.e. in get).

To signal end of data, simply send an empty QByteArray().

Parameters:

  | data | the data read by the slave

dataReq | ( |  | self ) |

Asks for data from the job.

See also:
  readData

del_ | ( | self, |
|  | KUrl | url,
|  | bool | isfile
| ) |  |  |

Delete a file or directory.

Parameters:

  | url | file/directory to delete
  | isfile | if true, a file should be deleted. if false, a directory should be deleted.

By default, del() on a directory should FAIL if the directory is not empty. However, if metadata("recurse") == "true", then the slave can do a recursive deletion. This behavior is only invoked if the slave specifies deleteRecursive=true in its protocol file.

disconnectSlave | ( |  | self ) |

dispatch | ( | self, |
|  | int | command,
|  | QByteArray | data
| ) |  |  |

Internal:

dispatchLoop | ( |  | self ) |

Internal:

dispatchOpenCommand | ( | self, |
|  | int | command,
|  | QByteArray | data
| ) |  |  |

Internal:

dropNetwork | ( | self, |
|  | QString | host=QString()
| ) |  |  |

Used by the slave to withdraw a connection requested by requestNetwork. This function cancels the last call to requestNetwork. If a client uses more than one internet connection, it must use dropNetwork(host) to stop each request.

If KNetMgr is not running, then this is a no-op.

Parameters:

  | host | the host passed to requestNetwork

A slave should call this function every time it disconnect from a host.

error | ( | self, |
|  | int | _errid,
|  | QString | _text
| ) |  |  |

Call to signal an error. This also finishes the job, so you must not call finished() after calling this.

If the error code is KIO.ERR_SLAVE_DEFINED then the _text should contain the complete translated text of of the error message.

For all other error codes, _text should match the corresponding error code. Usually,, _text is a file or host name, or the error which was passed from the server.
For example, for KIO.ERR_DOES_NOT_EXIST, _text may only be the file or folder which does not exist, nothing else. Otherwise, this would break error strings generated by KIO.buildErrorString().
If you have to add more details than what the standard error codes provide, you'll need to use KIO.ERR_SLAVE_DEFINED. For a complete list of what _text should contain for each error code, look at the source of KIO.buildErrorString().

You can add rich text markup to the message, the places where the error message will be displayed are rich text aware.

See also:
  KIO.Error

See also:
  KIO.buildErrorString

Parameters:

  | _errid | the error code from KIO.Error
  | _text | the rich text error message

errorPage | ( |  | self ) |

Tell that we will only get an error page here. This means: the data you'll get isn't the data you requested, but an error page (usually HTML) that describes an error.

exit | ( |  | self ) |

Internal:
  Terminate the slave by calling the destructor and then .exit()

finished | ( |  | self ) |

Call to signal successful completion of any command besides openConnection and closeConnection. Do not call this after calling error().

get | ( | self, |
|  | KUrl | url
| ) |  |  |

get, aka read.

Parameters:

  | url | the full url for this request. Host, port and user of the URL can be assumed to be the same as in the last setHost() call.

The slave should first "emit" the mimetype by calling mimeType(), and then "emit" the data using the data() method.

The reason why we need get() to emit the mimetype is: when pasting a URL in krunner, or konqueror's location bar, we have to find out what is the mimetype of that URL. Rather than doing it with a call to mimetype(), then the app or part would have to do a second request to the same server, this is done like this: get() is called, and when it emits the mimetype, the job is put on hold and the right app or part is launched. When that app or part calls get(), the slave is magically reused, and the download can now happen. All with a single call to get() in the slave. This mechanism is also described in KIO.get().

bool hasMetaData | ( | self, |
|  | QString | key
| ) |  |  |

Queries for the existence of a certain config/meta-data entry send by the application to the slave.

infoMessage | ( | self, |
|  | QString | msg
| ) |  |  |

Call to signal a message, to be displayed if the application wants to, for instance in a status bar. Usual examples are "connecting to host xyz", etc.

listDir | ( | self, |
|  | KUrl | url
| ) |  |  |

Lists the contents of url. The slave should emit ERR_CANNOT_ENTER_DIRECTORY if it doesn't exist, if we don't have enough permissions, or if it is a file It should also emit totalFiles as soon as it knows how many files it will list.

listEntries | ( | self, |
|  | [KIO.UDSEntry] | _entry
| ) |  |  |

Call this in listDir, each time you have a bunch of entries to report.

Parameters:

  | _entry | The UDSEntry containing all of the object attributes.

listEntry | ( | self, |
|  | KIO.UDSEntry | _entry,
|  | bool | ready
| ) |  |  |

internal function to be called by the slave. It collects entries and emits them via listEntries when enough of them are there or a certain time frame exceeded (to make sure the app gets some items in time but not too many items one by one as this will cause a drastic performance penalty)

Parameters:

  | _entry | The UDSEntry containing all of the object attributes.
  | ready | set to true after emitting all items. _entry is not used in this case

lookupHost | ( | self, |
|  | QString | host
| ) |  |  |

Internally used

Internal:

int messageBox | ( | self, |
|  | KIO.SlaveBase.MessageBoxType | type,
|  | QString | text,
|  | QString | caption=QString(),
|  | QString | buttonYes=i18n("&Yes"),
|  | QString | buttonNo=i18n("&No")
| ) |  |  |

Call this to show a message box from the slave

Parameters:

  | text | Message string. May contain newlines.
  | type | type of message box: QuestionYesNo, WarningYesNo, WarningContinueCancel...
  | caption | Message box title.
  | buttonYes | The text for the first button. The default is i18n("&Yes").
  | buttonNo | The text for the second button. The default is i18n("&No"). Note: for ContinueCancel, buttonYes is the continue button and buttonNo is unused. and for Information, none is used.
  | dontAskAgain | A checkbox is added with which further confirmation can be turned off. If the checkbox was ticked @p*dontAskAgain will be set to true, otherwise false.

Returns:
  a button code, as defined in KMessageBox, or 0 on communication error.

int messageBox | ( | self, |
|  | QString | text,
|  | KIO.SlaveBase.MessageBoxType | type,
|  | QString | caption=QString(),
|  | QString | buttonYes=i18n("&Yes"),
|  | QString | buttonNo=i18n("&No"),
|  | QString | dontAskAgainName=QString()
| ) |  |  |

Call this to show a message box from the slave

Parameters:

  | text | Message string. May contain newlines.
  | type | type of message box: QuestionYesNo, WarningYesNo, WarningContinueCancel...
  | caption | Message box title.
  | buttonYes | The text for the first button. The default is i18n("&Yes").
  | buttonNo | The text for the second button. The default is i18n("&No"). Note: for ContinueCancel, buttonYes is the continue button and buttonNo is unused. and for Information, none is used.
  | dontAskAgain | A checkbox is added with which further confirmation can be turned off. If the checkbox was ticked @p*dontAskAgain will be set to true, otherwise false.

Returns:
  a button code, as defined in KMessageBox, or 0 on communication error.

QString metaData | ( | self, |
|  | QString | key
| ) |  |  |

Queries for config/meta-data send by the application to the slave.

mimeType | ( | self, |
|  | QString | _type
| ) |  |  |

Call this in mimetype() and in get(), when you know the mimetype. See mimetype about other ways to implement it.

mimetype | ( | self, |
|  | KUrl | url
| ) |  |  |

Finds mimetype for one file or directory.

This method should either emit 'mimeType' or it should send a block of data big enough to be able to determine the mimetype.

If the slave doesn't reimplement it, a get will be issued, i.e. the whole file will be downloaded before determining the mimetype on it - this is obviously not a good thing in most cases.

mkdir | ( | self, |
|  | KUrl | url,
|  | int | permissions
| ) |  |  |

Create a directory

Parameters:

  | url | path to the directory to create
  | permissions | the permissions to set after creating the directory (-1 if no permissions to be set) The slave emits ERR_COULD_NOT_MKDIR if failure.

multiGet | ( | self, |
|  | QByteArray | data
| ) |  |  |

Used for multiple get. Currently only used foir HTTP pielining support.

Parameters:

  | data | packed data; Contains number of URLs to fetch, and for each URL the URL itself and its associated MetaData.

needSubUrlData | ( |  | self ) |

Call to signal that data from the sub-URL is needed

open | ( | self, |
|  | KUrl | url,
|  | QIODevice::OpenMode | mode
| ) |  |  |

open.

Parameters:

  | url | the full url for this request. Host, port and user of the URL can be assumed to be the same as in the last setHost() call.
  | mode | see QIODevice.OpenMode

openConnection | ( |  | self ) |

Opens the connection (forced) When this function gets called the slave is operating in connection-oriented mode. When a connection gets lost while the slave operates in connection oriented mode, the slave should report ERR_CONNECTION_BROKEN instead of reconnecting. The user is expected to disconnect the slave in the error handler.

bool openPasswordDialog | ( | self, |
|  | KIO.AuthInfo | info,
|  | QString | errorMsg=QString()
| ) |  |  |

Prompt the user for Authorization info (login & password).

Use this function to request authorization information from the end user. You can also pass an error message which explains why a previous authorization attempt failed. Here is a very simple example:

     KIO.AuthInfo authInfo;
     if ( openPasswordDialog( authInfo ) )
     {
        kDebug() << QLatin1String("User: ")
                  << authInfo.username << endl;
        kDebug() << QLatin1String("Password: ")
                  << QLatin1String("Not displayed here!") << endl;
     }

You can also preset some values like the username, caption or comment as follows:

     KIO.AuthInfo authInfo;
     authInfo.caption= "Acme Password Dialog";
     authInfo.username= "Wile E. Coyote";
     QString errorMsg = "You entered an incorrect password.";
     if ( openPasswordDialog( authInfo, errorMsg ) )
     {
        kDebug() << QLatin1String("User: ")
                  << authInfo.username << endl;
        kDebug() << QLatin1String("Password: ")
                  << QLatin1String("Not displayed here!") << endl;
     }

Note:
  You should consider using checkCachedAuthentication() to see if the password is available in kpasswdserver before calling this function.

Note:
  A call to this function can fail and return false, if the UIServer could not be started for whatever reason.

Note:
  Starting with KDE 4.7, this function will no longer store the password information automatically. If you want to store the password information in a persistent storage like KWallet, then you MUST call cacheAuthentication.

See also:
  checkCachedAuthentication

Parameters:

  | info | See AuthInfo.
  | errorMsg | Error message to show

Returns:
  true if user clicks on "OK", false otherwsie.

opened | ( |  | self ) |

open succedes

See also:
  open

position | ( | self, |
|  | long | _pos
| ) |  |  |

processedPercent | ( | self, |
|  | float | percent
| ) |  |  |

Only use this if you can't know in advance the size of the copied data. For example, if you're doing variable bitrate compression of the source.

STUB ! Currently unimplemented. Here now for binary compatibility.

Call this during get and copy, once in a while, to give some info about the current state. Don't emit it in listDir, listEntries speaks for itself.

processedSize | ( | self, |
|  | long | _bytes
| ) |  |  |

Call this during get and copy, once in a while, to give some info about the current state. Don't emit it in listDir, listEntries speaks for itself.

int proxyConnectTimeout | ( |  | self ) |

Returns:
  timeout value for connecting to proxy in secs.

put | ( | self, |
|  | KUrl | url,
|  | int | permissions,
|  | KIO.JobFlags | flags
| ) |  |  |

put, i.e. write data into a file.

Parameters:

  | url | where to write the file
  | permissions | may be -1. In this case no special permission mode is set.
  | flags: | We support Overwrite here. Hopefully, we're going to support Resume in the future, too. If the file indeed already exists, the slave should NOT apply the permissions change to it. The support for resuming using .part files is done by calling canResume().

IMPORTANT: Use the "modified" metadata in order to set the modification time of the file.

See also:
  canResume()

read | ( | self, |
|  | long | size
| ) |  |  |

int readData | ( | self, |
|  | QByteArray | buffer
| ) |  |  |

Read data sent by the job, after a dataReq

Parameters:

  | buffer | buffer where data is stored

Returns:
  0 on end of data, > 0 bytes read < 0 error

int readTimeout | ( |  | self ) |

Returns:
  timeout value for read from subsequent data from remote host in secs.

redirection | ( | self, |
|  | KUrl | _url
| ) |  |  |

Call this to signal a redirection The job will take care of going to that url.

KRemoteEncoding remoteEncoding | ( |  | self ) |

Returns an object that can translate remote filenames into proper Unicode forms. This encoding can be set by the user.

rename | ( | self, |
|  | KUrl | src,
|  | KUrl | dest,
|  | KIO.JobFlags | flags
| ) |  |  |

Rename oldname into newname. If the slave returns an error ERR_UNSUPPORTED_ACTION, the job will ask for copy + del instead.

Important: the slave must implement the logic "if the destination already exists, error ERR_DIR_ALREADY_EXIST or ERR_FILE_ALREADY_EXIST". For performance reasons no stat is done in the destination before hand, the slave must do it.

By default, rename() is only called when renaming (moving) from yourproto://host/path to yourproto://host/otherpath.

If you set renameFromFile=true then rename() will also be called when moving a file from file:path to yourproto://host/otherpath. Otherwise such a move would have to be done the slow way (copy+delete). See KProtocolManager.canRenameFromFile() for more details.

If you set renameToFile=true then rename() will also be called when moving a file from yourproto: to file:. See KProtocolManager.canRenameToFile() for more details.

Parameters:

  | src | where to move the file from
  | dest | where to move the file to
  | flags: | We support Overwrite here

reparseConfiguration | ( |  | self ) |

Called by the scheduler to tell the slave that the configuration changed (i.e. proxy settings) .

bool requestNetwork | ( | self, |
|  | QString | host=QString()
| ) |  |  |

Used by the slave to check if it can connect to a given host. This should be called where the slave is ready to do a .connect() on a socket. For each call to requestNetwork must exist a matching call to dropNetwork, or the system will stay online until KNetMgr gets closed (or the SlaveBase gets destructed)!

If KNetMgr is not running, then this is a no-op and returns true

Parameters:

  | host | tells the netmgr the host the slave wants to connect to. As this could also be a proxy, we can't just take the host currenctly connected to (but that's the default value)

Returns:
  true in theorie, the host is reachable false the system is offline and the host is in a remote network.

int responseTimeout | ( |  | self ) |

Returns:
  timeout value for read from first data from remote host in seconds.

seek | ( | self, |
|  | long | offset
| ) |  |  |

sendAndKeepMetaData | ( |  | self ) |

Internal function to transmit meta data to the application. Like sendMetaData() but m_outgoingMetaData will not be cleared. This method is mainly useful in code that runs before the slave is connected to its final job.

sendMetaData | ( |  | self ) |

Internal function to transmit meta data to the application. m_outgoingMetaData will be cleared; this means that if the slave is for example put on hold and picked up by a different KIO.Job later the new job will not see the metadata sent before. See kio/DESIGN.krun for an overview of the state progression of a job/slave.

Warning:
  calling this method may seriously interfere with the operation of KIO which relies on the presence of some metadata at some points in time. You should not use it if you are not familiar with KIO and not before the slave is connected to the last job before returning to idle state.

setHost | ( | self, |
|  | QString | host,
|  | int | port,
|  | QString | user,
|  | QString | pass
| ) |  |  |

Set the host

Parameters:

  | host |
  | port |
  | user |
  | pass | Called directly by createSlave, this is why there is no equivalent in SlaveInterface, unlike the other methods.

This method is called whenever a change in host, port or user occurs.

setKillFlag | ( |  | self ) |

Internally used.

Internal:

setLinkDest | ( | self, |
|  | KUrl | url,
|  | QString | target
| ) |  |  |

Change the destination of a symlink

Parameters:

  | url | the url of the symlink to modify
  | target | the new destination (target) of the symlink

setMetaData | ( | self, |
|  | QString | key,
|  | QString | value
| ) |  |  |

Sets meta-data to be send to the application before the first data() or finished() signal.

setModificationTime | ( | self, |
|  | KUrl | url,
|  | QDateTime | mtime
| ) |  |  |

Sets the modification time for url For instance this is what CopyJob uses to set mtime on dirs at the end of a copy. It could also be used to set the mtime on any file, in theory. The usual implementation on unix is to call utime(path, &myutimbuf). The slave emits ERR_DOES_NOT_EXIST or ERR_CANNOT_SETTIME

setSubUrl | ( | self, |
|  | KUrl | url
| ) |  |  |

Prepare slave for streaming operation

setTimeoutSpecialCommand | ( | self, |
|  | int | timeout,
|  | QByteArray | data=QByteArray()
| ) |  |  |

This function sets a timeout of timeout seconds and calls special(data) when the timeout occurs as if it was called by the application.

A timeout can only occur when the slave is waiting for a command from the application.

Specifying a negative timeout cancels a pending timeout.

Only one timeout at a time is supported, setting a timeout cancels any pending timeout.

slaveStatus | ( | self, |
|  | QString | host,
|  | bool | connected
| ) |  |  |

Used to report the status of the slave.

Parameters:

  | host | the slave is currently connected to. (Should be empty if not connected)
  | connected | Whether an actual network connection exists.

slave_status | ( |  | self ) |

Called to get the status of the slave. Slave should respond by calling slaveStatus(...)

special | ( | self, |
|  | QByteArray | data
| ) |  |  |

Used for any command that is specific to this slave (protocol) Examples are : HTTP POST, mount and unmount (kio_file)

Parameters:

  | data | packed data; the meaning is completely dependent on the slave, but usually starts with an int for the command number. Document your slave's commands, at least in its header file.

speed | ( | self, |
|  | long | _bytes_per_second
| ) |  |  |

Call this in get and copy, to give the current transfer speed, but only if it can't be calculated out of the size you passed to processedSize (in most cases you don't want to call it)

stat | ( | self, |
|  | KUrl | url
| ) |  |  |

Finds all details for one file or directory. The information returned is the same as what listDir returns, but only for one file or directory. Call statEntry() after creating the appropriate UDSEntry for this url.

You can use the "details" metadata to optimize this method to only do as much work as needed by the application. By default details is 2 (all details wanted, including modification time, size, etc.), details==1 is used when deleting: we don't need all the information if it takes too much time, no need to follow symlinks etc. details==0 is used for very simple probing: we'll only get the answer "it's a file or a directory (or a symlink), or it doesn't exist".

statEntry | ( | self, |
|  | KIO.UDSEntry | _entry
| ) |  |  |

Call this from stat() to express details about an object, the UDSEntry customarily contains the atoms describing file name, size, mimetype, etc.

Parameters:

  | _entry | The UDSEntry containing all of the object attributes.

symlink | ( | self, |
|  | QString | target,
|  | KUrl | dest,
|  | KIO.JobFlags | flags
| ) |  |  |

Creates a symbolic link named dest, pointing to target, which may be a relative or an absolute path.

Parameters:

  | target | The string that will become the "target" of the link (can be relative)
  | dest | The symlink to create.
  | flags: | We support Overwrite here

totalSize | ( | self, |
|  | long | _bytes
| ) |  |  |

Call this in get and copy, to give the total size of the file Call in listDir too, when you know the total number of items.

int, int pCmd waitForAnswer | ( | self, |
|  | int | expected1,
|  | int | expected2,
|  | QByteArray | data
| ) |  |  |

Wait for an answer to our request, until we get expected1 or expected2

Returns:
  the result from readData, as well as the cmd in *pCmd if set, and the data in data

int waitForHostInfo | ( | self, |
|  | QHostInfo | info
| ) |  |  |

Internally used

Internal:

warning | ( | self, |
|  | QString | msg
| ) |  |  |

Call to signal a warning, to be displayed in a dialog box.

bool wasKilled | ( |  | self ) |

If your ioslave was killed by a signal, wasKilled() returns true. Check it regularly in lengthy functions (e.g. in get();) and return as fast as possible from this function if wasKilled() returns true. This will ensure that your slave destructor will be called correctly.

write | ( | self, |
|  | QByteArray | data
| ) |  |  |

written | ( | self, |
|  | long | _bytes
| ) |  |  |

## Enumeration Documentation

MessageBoxType

Enumerator:

  QuestionYesNo = 1 |
  WarningYesNo = 2 |
  WarningContinueCancel = 3 |
  WarningYesNoCancel = 4 |
  Information = 5 |
  SSLMessageBox = 6 |

VirtualFunctionId

Name of the protocol supported by this slave

Enumerator:

  AppConnectionMade = 0 |